from System.Collections.Generic import List
from System import Byte, Int32
import sys

#
# Set this to the exact name of your pick script .. capital matters
# and it has to be in your list of scripts on UI
#
#
# First keep track of position in book 
#
RuneBook = 0x400F5DC0
if Player.Name == "Greed":
    RuneBook = 0x4225978D
#
#
# Next keep track of position in book. At end of a book we'll set next book 
#
RuneOrder = [ 7, 13, 19, 25, 31, 37, 43, 49, 55, 61] #, 59, 65, 71, 77, 83, 95 ] 
#
# A function I'll need later to check if runbook entry is Empty
#
def RuneBookFirstNameIndex():    
    gumpList = Gumps.LastGumpGetLineList()
    textParts = ["Charges:", "Max Charges:", "Rename book", "Drop rune", 
                 "Set default", "Recall", "Gate Travel", "Sacred Journey" ]
    index = 0
    #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
    while gumpList[index].strip() in textParts:
        #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
        index = index + 1
        # now index should be at the charges numbers so skip 1 more
    index = index + 2
    #Misc.SendMessage("Starts at: {}".format(index))
    return index

def DistanceTo(x, y):
    return (((Player.Position.X - x)**2) + ((Player.Position.Y - y)**2))**.5
    
def TransportToRuneIndex(RuneIndex):
    Gumps.ResetGump()
    bookOpen = False
    while not bookOpen:
        Items.UseItem(RuneBook)
        Gumps.WaitForGump(Gumps.CurrentGump(), 1000)
        if Gumps.HasGump():
            bookOpen = True
    #        
    bookSlotName = Gumps.LastGumpGetLine(RuneBookFirstNameIndex()+RuneIndex)
    Misc.SendMessage(bookSlotName.strip().lower()) 
    if bookSlotName.strip().lower() != "empty":
        Gumps.SendAction(Gumps.CurrentGump(), RuneOrder[RuneIndex])
    #Misc.Resync()
    Misc.Pause(5000)

def FindAny(itemArray):
    for item in itemArray:
        if Items.FindByID(item, -1, Player.Backpack.Serial):
            return True
    return False

    
def kill(name):
    filter = Mobiles.Filter()
    filter.Name = name
    filter.RangeMax = 20
    mobs = Mobiles.ApplyFilter(filter)
    Misc.SendMessage("Number Mobs with name {}: {}".format(name, len(mobs)) )
    if len(mobs) > 0:
        Player.SetWarMode(True)
        mob = mobs[0]
        while None != Mobiles.FindBySerial(mob.Serial): 
            w_r = Player.GetItemOnLayer('RightHand')
            Misc.SendMessage("right={}".format(w_r))
            w_l = Player.GetItemOnLayer('LeftHand')
            #Misc.SendMessage("left={}".format(w_l))
            if w_l != None: 
                weapon = w_l
                Misc.Pause(500)
            elif w_r != None:    
                weapon = w_r
                Misc.Pause(500)
            else:
                weapon = None                            
            range = Items.GetPropValue(weapon, 'Range') 
            if range < 2:
                range = 2             
            if Player.DistanceTo(mob) > range:
                route = PathFinding.Route()
                route.X = mob.Position.X
                route.Y = mob.Position.Y
                route.UseResync = False
                route.MaxRetry = 2
                PathFinding.Go(route)                
            Player.Attack(mob)
            Misc.Pause(1000)    
    Misc.Pause(1000)    
    Player.SetWarMode(False)        
                
def get_quest():
    NPC = Mobiles.FindBySerial(0x000065DA) 
    Misc.SendMessage("Should get Quest")
    if Player.DistanceTo(NPC) > 2:
        Player.PathFindTo(NPC.Position.X, NPC.Position.Y, NPC.Position.Z)
        while Player.DistanceTo(NPC) > 2:
            Misc.Pause(1000)
    noQuest = True
    Misc.Pause(2000)
    while noQuest:
        while not Gumps.HasGump():
            Journal.Clear() 
            Misc.WaitForContext(NPC, 60000)
            Misc.Pause(1000)
            Misc.ContextReply(NPC, "Talk")
            Misc.Pause(1000)
            if Journal.Search("Could you check back"):
                Misc.SendMessage("DEBUG")
                noQuest = True
                Player.UseSkill("Hiding")
                Misc.Pause(5*60000)
            elif Journal.Search("Talk not exist"):
                noQuest = True
                Misc.Pause(1000)
                continue
            else:
                noQuest = False                
    Gumps.WaitForGump(0, 1000)
    if Gumps.LastGumpTextExist("I don't know how much longer"):
        Gumps.SendAction(0, 0)
    elif Gumps.LastGumpTextExist("Quest Offer"):
        Gumps.SendAction(0, 4)    

def branding_iron():
    Misc.SendMessage("Kill the Laird")
    kill("Laird")
    
def horse_shoes():
    Misc.SendMessage("Horse Shoes")
    kill("a reaper horse")

def leather_strap():
    kill("Lord Falek")
    
def hoof_knife():    
    kill("Rulf")
    
    
def first_meeting_loreena():
    Misc.Pause(2000)
    NPC = Mobiles.FindBySerial(0x000065D9)       
    Misc.Pause(2000)    
    Misc.SendMessage("Talk to Loreena first time")
    
    if Player.DistanceTo(NPC) > 2:
        Player.PathFindTo(NPC.Position.X, NPC.Position.Y, NPC.Position.Z)
        while Player.DistanceTo(NPC) > 2:
            Misc.Pause(1000)        
    Misc.WaitForContext(NPC, 20000)
    Misc.Pause(1000)
    Misc.ContextReply(NPC, "Talk")
    Misc.Pause(3000)
    
def meet_thorwald():
    Misc.Pause(2000)
    Misc.SendMessage("Meet Thorwald")
    Misc.Pause(2000)    
    NPC = Mobiles.FindBySerial(0x000065DB)
    if Player.DistanceTo(NPC) > 2:
        Player.PathFindTo(NPC.Position.X, NPC.Position.Y, NPC.Position.Z)
        while Player.DistanceTo(NPC) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(NPC, 20000)
    Misc.Pause(1000)
    Misc.ContextReply(NPC, "Talk")            
    Misc.Pause(2000)        
    
    
def second_meeting_loreena():
    Misc.Pause(2000)
    NPC = Mobiles.FindBySerial(0x000065D9)  
    Misc.Pause(2000)    
    Misc.SendMessage("Talk to Loreena second time")
    if Player.DistanceTo(NPC) > 2:
        Player.PathFindTo(NPC.Position.X, NPC.Position.Y, NPC.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(NPC, 30000)
    Misc.Pause(1000)
    Misc.ContextReply(NPC, "Talk")
    Misc.Pause(2000)
    Items.WaitForContents(Player.Backpack, 3000)
    
def mark_quest_item():    
    questItem = Items.FindByID (0x1EBB, 0, Player.Backpack.Serial)
    if questItem != None:
        Misc.WaitForContext(Player.Serial, 20000)
        Misc.ContextReply(Player.Serial, "Toggle Quest Item")
        Target.WaitForTarget(3000)
        Misc.Pause(1000)
        Target.TargetExecute(questItem.Serial)
        Target.Cancel()
        Misc.SendToClient("{ESC}\n")

def finish_quest():
    Misc.SendMessage("Should get Quest")
    questGiver = Mobiles.FindBySerial(0x000065DA)
    if Player.DistanceTo(questGiver) > 2:
        Player.PathFindTo(questGiver.Position.X, questGiver.Position.Y, questGiver.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(questGiver, 30000)
    Misc.Pause(1000)
    Misc.ContextReply(questGiver, "Talk")
    Gumps.WaitForGump(0, 5000)
    Gumps.SendAction(0, 8)
    Gumps.WaitForGump(0, 5000)
    Gumps.SendAction(0, 5)    
#        
#
# Now finally everything is set. 
#
#
# RuneBookIndex is set to the current book to use
# RuneIndex is set to which rune in that book to use
# 0x10E7
Action = [ [get_quest, 0x0 ], 
    [branding_iron, [0x9E87, 0x9E88]], 
    [horse_shoes, [0x0FB6] ], 
    [leather_strap, [0x166E] ], 
    [hoof_knife, [0x10E7] ], 
    [first_meeting_loreena, [0xAA82, 0xAA83] ], 
    [meet_thorwald, [0xA2C4, 0xA2C5] ],
    [second_meeting_loreena, [0x1EBB] ],
    [mark_quest_item, [0x09A1] ],
    [finish_quest, [0x1039] ],         
    ]
    
state = 0
while state != len(Action):
    
    if FindAny(Action[4][1]):
        Misc.SendMessage("Found 0x{:x}".format(0x10e7))
        state = 5
    if FindAny(Action[5][1]):
        Misc.SendMessage("Found 0x{:x}".format(0xAA83))
        state = 6 
    if FindAny(Action[6][1]):
        Misc.SendMessage("Found 0x{:x}".format(0xA2C5))
        state = 7  
    if FindAny(Action[7][1]):
        Misc.SendMessage("Found 0x{:x}".format(0x1EBB))
        state = 8  
    #    
    if state == 0:
        if DistanceTo(1289, 1758) > 2:        
            TransportToRuneIndex(state)
        Action[state][0]()
        state = state + 1  
    while state >= 1 and state <= 7: 
        Misc.SendMessage("Checking state: {}".format(state))       
        if not FindAny(Action[state][1]):
            TransportToRuneIndex(state)
            Action[state][0]()
        if FindAny(Action[state][1]):
            Misc.SendMessage("incrementing state: {}".format(state))     
            state = state + 1 
        #
    if state == 8:
        Misc.SendMessage("Checking state: {}".format(state))
        if not FindAny(Action[state][1]):
            Misc.SendMessage("Mark Quest Item")
            Action[state][0]()
        state = state + 1
    if state == 9:
        Misc.SendMessage("Checking state: {}".format(state))
        if DistanceTo(1289, 1758) > 2:        
            TransportToRuneIndex(8)
        Action[state][0]()
        state = state + 1
        Misc.Pause(1000)
    # 
    TransportToRuneIndex(9)
    Target.Cancel()
    
    

